Index: squid/src/auth/basic/helpers/MSNT/smblib.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/smblib.c:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/MSNT/smblib.c	Tue Sep  3 10:42:15 2002
@@ -0,0 +1,554 @@
+/* UNIX SMBlib NetBIOS implementation
+ * 
+ * Version 1.0
+ * SMBlib Routines
+ * 
+ * Copyright (C) Richard Sharpe 1996
+ * 
+ */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+int SMBlib_errno;
+int SMBlib_SMB_Error;
+#define SMBLIB_ERRNO
+#define uchar unsigned char
+#include "smblib-priv.h"
+#include "smblib.h"
+#include "rfcnb-priv.h"
+#include "rfcnb.h"
+#include "rfcnb-util.h"
+
+#include <stdlib.h>
+#include <unistd.h>
+#include <ctype.h>
+#include <string.h>
+#include <signal.h>
+
+SMB_State_Types SMBlib_State;
+
+extern int RFCNB_Set_Sock_NoDelay(RFCNB_Con *, BOOL);
+extern void SMB_Get_My_Name(char *, int);
+
+/* Initialize the SMBlib package     */
+
+int
+SMB_Init()
+{
+
+    SMBlib_State = SMB_State_Started;
+
+    signal(SIGPIPE, SIG_IGN);	/* Ignore these ... */
+
+/* If SMBLIB_Instrument is defines, turn on the instrumentation stuff */
+#ifdef SMBLIB_INSTRUMENT
+
+    SMBlib_Instrument_Init();
+
+#endif
+
+    return 0;
+
+}
+
+int
+SMB_Term()
+{
+
+#ifdef SMBLIB_INSTRUMENT
+
+    SMBlib_Instrument_Term();	/* Clean up and print results */
+
+#endif
+
+    return 0;
+
+}
+
+/* SMB_Create: Create a connection structure and return for later use */
+/* We have other helper routines to set variables                     */
+
+SMB_Handle_Type
+SMB_Create_Con_Handle(void)
+{
+
+    SMBlib_errno = SMBlibE_NotImpl;
+    return (NULL);
+
+}
+
+int
+SMBlib_Set_Sock_NoDelay(SMB_Handle_Type Con_Handle, BOOL yn)
+{
+
+
+    if (RFCNB_Set_Sock_NoDelay(Con_Handle->Trans_Connect, yn) < 0) {
+
+#ifdef DEBUG
+#endif
+
+	fprintf(stderr, "Setting no-delay on TCP socket failed ...\n");
+
+    }
+    return (0);
+
+}
+
+/* SMB_Connect_Server: Connect to a server, but don't negotiate protocol */
+/* or anything else ...                                                  */
+
+SMB_Handle_Type
+SMB_Connect_Server(SMB_Handle_Type Con_Handle,
+    char *server, char *NTdomain)
+{
+    SMB_Handle_Type con;
+    char called[80], calling[80], *address;
+    int i;
+
+    /* Get a connection structure if one does not exist */
+
+    con = Con_Handle;
+
+    if (Con_Handle == NULL) {
+
+	if ((con = (struct SMB_Connect_Def *) malloc(sizeof(struct SMB_Connect_Def))) == NULL) {
+
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    return NULL;
+	}
+    }
+    /* Init some things ... */
+
+    strcpy(con->service, "");
+    strcpy(con->username, "");
+    strcpy(con->password, "");
+    strcpy(con->sock_options, "");
+    strcpy(con->address, "");
+    strcpy(con->desthost, server);
+    strcpy(con->PDomain, NTdomain);
+    strcpy(con->OSName, SMBLIB_DEFAULT_OSNAME);
+    strcpy(con->LMType, SMBLIB_DEFAULT_LMTYPE);
+    con->first_tree = con->last_tree = NULL;
+
+    SMB_Get_My_Name(con->myname, sizeof(con->myname));
+
+    con->port = 0;		/* No port selected */
+
+    /* Get some things we need for the SMB Header */
+
+    con->pid = getpid();
+    con->mid = con->pid;	/* This will do for now ... */
+    con->uid = 0;		/* Until we have done a logon, no uid ... */
+    con->gid = getgid();
+
+    /* Now connect to the remote end, but first upper case the name of the
+     * service we are going to call, sine some servers want it in uppercase */
+
+    for (i = 0; i < strlen(server); i++)
+	called[i] = toupper(server[i]);
+
+    called[strlen(server)] = 0;	/* Make it a string */
+
+    for (i = 0; i < strlen(con->myname); i++)
+	calling[i] = toupper(con->myname[i]);
+
+    calling[strlen(con->myname)] = 0;	/* Make it a string */
+
+    if (strcmp(con->address, "") == 0)
+	address = con->desthost;
+    else
+	address = con->address;
+
+    con->Trans_Connect = RFCNB_Call(called,
+	calling,
+	address,		/* Protocol specific */
+	con->port);
+
+    /* Did we get one? */
+
+    if (con->Trans_Connect == NULL) {
+
+	if (Con_Handle == NULL) {
+	    Con_Handle = NULL;
+	    free(con);
+	}
+	SMBlib_errno = -SMBlibE_CallFailed;
+	return NULL;
+
+    }
+    return (con);
+
+}
+
+/* SMB_Connect: Connect to the indicated server                       */
+/* If Con_Handle == NULL then create a handle and connect, otherwise  */
+/* use the handle passed                                              */
+
+char *SMB_Prots_Restrict[] =
+{"PC NETWORK PROGRAM 1.0",
+    NULL};
+
+
+SMB_Handle_Type
+SMB_Connect(SMB_Handle_Type Con_Handle,
+    SMB_Tree_Handle * tree,
+    char *service,
+    char *username,
+    char *password)
+{
+    SMB_Handle_Type con;
+    char *host, *address;
+    char temp[80], called[80], calling[80];
+    int i;
+
+    /* Get a connection structure if one does not exist */
+
+    con = Con_Handle;
+
+    if (Con_Handle == NULL) {
+
+	if ((con = (struct SMB_Connect_Def *) malloc(sizeof(struct SMB_Connect_Def))) == NULL) {
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    return NULL;
+	}
+    }
+    /* Init some things ... */
+
+    strcpy(con->service, service);
+    strcpy(con->username, username);
+    strcpy(con->password, password);
+    strcpy(con->sock_options, "");
+    strcpy(con->address, "");
+    strcpy(con->PDomain, SMBLIB_DEFAULT_DOMAIN);
+    strcpy(con->OSName, SMBLIB_DEFAULT_OSNAME);
+    strcpy(con->LMType, SMBLIB_DEFAULT_LMTYPE);
+    con->first_tree = con->last_tree = NULL;
+
+    SMB_Get_My_Name(con->myname, sizeof(con->myname));
+
+    con->port = 0;		/* No port selected */
+
+    /* Get some things we need for the SMB Header */
+
+    con->pid = getpid();
+    con->mid = con->pid;	/* This will do for now ... */
+    con->uid = 0;		/* Until we have done a logon, no uid */
+    con->gid = getgid();
+
+    /* Now figure out the host portion of the service */
+
+    strcpy(temp, service);
+    /* AI - Added (char *) to stop compiler warnings */
+    host = (char *) strtok(temp, "/\\");	/* Separate host name portion */
+    strcpy(con->desthost, host);
+
+    /* Now connect to the remote end, but first upper case the name of the
+     * service we are going to call, sine some servers want it in uppercase */
+
+    for (i = 0; i < strlen(host); i++)
+	called[i] = toupper(host[i]);
+
+    called[strlen(host)] = 0;	/* Make it a string */
+
+    for (i = 0; i < strlen(con->myname); i++)
+	calling[i] = toupper(con->myname[i]);
+
+    calling[strlen(con->myname)] = 0;	/* Make it a string */
+
+    if (strcmp(con->address, "") == 0)
+	address = con->desthost;
+    else
+	address = con->address;
+
+    con->Trans_Connect = RFCNB_Call(called,
+	calling,
+	address,		/* Protocol specific */
+	con->port);
+
+    /* Did we get one? */
+
+    if (con->Trans_Connect == NULL) {
+
+	if (Con_Handle == NULL) {
+	    free(con);
+	    Con_Handle = NULL;
+	}
+	SMBlib_errno = -SMBlibE_CallFailed;
+	return NULL;
+
+    }
+    /* Now, negotiate the protocol */
+
+    if (SMB_Negotiate(con, SMB_Prots_Restrict) < 0) {
+
+	/* Hmmm what should we do here ... We have a connection, but could not
+	 * negotiate ...                                                      */
+
+	return NULL;
+
+    }
+    /* Now connect to the service ... */
+
+    if ((*tree = SMB_TreeConnect(con, NULL, service, password, "A:")) == NULL) {
+
+	return NULL;
+
+    }
+    return (con);
+
+}
+
+/* Logon to the server. That is, do a session setup if we can. We do not do */
+/* Unicode yet!                                                             */
+
+int
+SMB_Logon_Server(SMB_Handle_Type Con_Handle, char *UserName,
+    char *PassWord)
+{
+    struct RFCNB_Pkt *pkt;
+    int param_len, pkt_len, pass_len;
+    char *p, pword[128];
+
+    /* First we need a packet etc ... but we need to know what protocol has  */
+    /* been negotiated to figure out if we can do it and what SMB format to  */
+    /* use ...                                                               */
+
+    if (Con_Handle->protocol < SMB_P_LanMan1) {
+
+	SMBlib_errno = SMBlibE_ProtLow;
+	return (SMBlibE_BAD);
+
+    }
+    strcpy(pword, PassWord);
+#ifdef PAM_SMB_ENC_PASS
+    if (Con_Handle->encrypt_passwords) {
+	pass_len = 24;
+	SMBencrypt((uchar *) PassWord, (uchar *) Con_Handle->Encrypt_Key, (uchar *) pword);
+    } else
+#endif
+	pass_len = strlen(pword);
+
+
+    /* Now build the correct structure */
+
+    if (Con_Handle->protocol < SMB_P_NT1) {
+
+	param_len = strlen(UserName) + 1 + pass_len + 1 +
+	    strlen(Con_Handle->PDomain) + 1 +
+	    strlen(Con_Handle->OSName) + 1;
+
+	pkt_len = SMB_ssetpLM_len + param_len;
+
+	pkt = (struct RFCNB_Pkt *) RFCNB_Alloc_Pkt(pkt_len);
+
+	if (pkt == NULL) {
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    return (SMBlibE_BAD);	/* Should handle the error */
+
+	}
+	bzero(SMB_Hdr(pkt), SMB_ssetpLM_len);
+	SIVAL(SMB_Hdr(pkt), SMB_hdr_idf_offset, SMB_DEF_IDF);	/* Plunk in IDF */
+	*(SMB_Hdr(pkt) + SMB_hdr_com_offset) = SMBsesssetupX;
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_pid_offset, Con_Handle->pid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_tid_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_mid_offset, Con_Handle->mid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_uid_offset, Con_Handle->uid);
+	*(SMB_Hdr(pkt) + SMB_hdr_wct_offset) = 10;
+	*(SMB_Hdr(pkt) + SMB_hdr_axc_offset) = 0xFF;	/* No extra command */
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_axo_offset, 0);
+
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_mbs_offset, SMBLIB_MAX_XMIT);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_mmc_offset, 2);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_vcn_offset, Con_Handle->pid);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpLM_snk_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_pwl_offset, pass_len + 1);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpLM_res_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_bcc_offset, param_len);
+
+	/* Now copy the param strings in with the right stuff */
+
+	p = (char *) (SMB_Hdr(pkt) + SMB_ssetpLM_buf_offset);
+
+	/* Copy  in password, then the rest. Password has a null at end */
+
+	memcpy(p, pword, pass_len);
+
+	p = p + pass_len + 1;
+
+	strcpy(p, UserName);
+	p = p + strlen(UserName);
+	*p = 0;
+
+	p = p + 1;
+
+	strcpy(p, Con_Handle->PDomain);
+	p = p + strlen(Con_Handle->PDomain);
+	*p = 0;
+	p = p + 1;
+
+	strcpy(p, Con_Handle->OSName);
+	p = p + strlen(Con_Handle->OSName);
+	*p = 0;
+
+    } else {
+
+	/* We don't admit to UNICODE support ... */
+
+	param_len = strlen(UserName) + 1 + pass_len +
+	    strlen(Con_Handle->PDomain) + 1 +
+	    strlen(Con_Handle->OSName) + 1 +
+	    strlen(Con_Handle->LMType) + 1;
+
+	pkt_len = SMB_ssetpNTLM_len + param_len;
+
+	pkt = (struct RFCNB_Pkt *) RFCNB_Alloc_Pkt(pkt_len);
+
+	if (pkt == NULL) {
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    return (-1);	/* Should handle the error */
+
+	}
+	bzero(SMB_Hdr(pkt), SMB_ssetpNTLM_len);
+	SIVAL(SMB_Hdr(pkt), SMB_hdr_idf_offset, SMB_DEF_IDF);	/* Plunk in IDF */
+	*(SMB_Hdr(pkt) + SMB_hdr_com_offset) = SMBsesssetupX;
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_pid_offset, Con_Handle->pid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_tid_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_mid_offset, Con_Handle->mid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_uid_offset, Con_Handle->uid);
+	*(SMB_Hdr(pkt) + SMB_hdr_wct_offset) = 13;
+	*(SMB_Hdr(pkt) + SMB_hdr_axc_offset) = 0xFF;	/* No extra command */
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_axo_offset, 0);
+
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_mbs_offset, SMBLIB_MAX_XMIT);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_mmc_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_vcn_offset, 0);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_snk_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_cipl_offset, pass_len);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_cspl_offset, 0);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_res_offset, 0);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_cap_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_bcc_offset, param_len);
+
+	/* Now copy the param strings in with the right stuff */
+
+	p = (char *) (SMB_Hdr(pkt) + SMB_ssetpNTLM_buf_offset);
+
+	/* Copy  in password, then the rest. Password has no null at end */
+
+	memcpy(p, pword, pass_len);
+
+	p = p + pass_len;
+
+	strcpy(p, UserName);
+	p = p + strlen(UserName);
+	*p = 0;
+
+	p = p + 1;
+
+	strcpy(p, Con_Handle->PDomain);
+	p = p + strlen(Con_Handle->PDomain);
+	*p = 0;
+	p = p + 1;
+
+	strcpy(p, Con_Handle->OSName);
+	p = p + strlen(Con_Handle->OSName);
+	*p = 0;
+	p = p + 1;
+
+	strcpy(p, Con_Handle->LMType);
+	p = p + strlen(Con_Handle->LMType);
+	*p = 0;
+
+    }
+
+    /* Now send it and get a response */
+
+    if (RFCNB_Send(Con_Handle->Trans_Connect, pkt, pkt_len) < 0) {
+
+#ifdef DEBUG
+	fprintf(stderr, "Error sending SessSetupX request\n");
+#endif
+
+	RFCNB_Free_Pkt(pkt);
+	SMBlib_errno = SMBlibE_SendFailed;
+	return (SMBlibE_BAD);
+
+    }
+    /* Now get the response ... */
+
+    if (RFCNB_Recv(Con_Handle->Trans_Connect, pkt, pkt_len) < 0) {
+
+#ifdef DEBUG
+	fprintf(stderr, "Error receiving response to SessSetupAndX\n");
+#endif
+
+	RFCNB_Free_Pkt(pkt);
+	SMBlib_errno = SMBlibE_RecvFailed;
+	return (SMBlibE_BAD);
+
+    }
+    /* Check out the response type ... */
+
+    if (CVAL(SMB_Hdr(pkt), SMB_hdr_rcls_offset) != SMBC_SUCCESS) {	/* Process error */
+
+#ifdef DEBUG
+	fprintf(stderr, "SMB_SessSetupAndX failed with errorclass = %i, Error Code = %i\n",
+	    CVAL(SMB_Hdr(pkt), SMB_hdr_rcls_offset),
+	    SVAL(SMB_Hdr(pkt), SMB_hdr_err_offset));
+#endif
+
+	SMBlib_SMB_Error = IVAL(SMB_Hdr(pkt), SMB_hdr_rcls_offset);
+	RFCNB_Free_Pkt(pkt);
+	SMBlib_errno = SMBlibE_Remote;
+	return (SMBlibE_BAD);
+
+    }
+#ifdef DEBUG
+    fprintf(stderr, "SessSetupAndX response. Action = %i\n",
+	SVAL(SMB_Hdr(pkt), SMB_ssetpr_act_offset));
+#endif
+
+    /* Now pick up the UID for future reference ... */
+
+    Con_Handle->uid = SVAL(SMB_Hdr(pkt), SMB_hdr_uid_offset);
+    RFCNB_Free_Pkt(pkt);
+
+    return (0);
+
+}
+
+
+/* Disconnect from the server, and disconnect all tree connects */
+
+int
+SMB_Discon(SMB_Handle_Type Con_Handle, BOOL KeepHandle)
+{
+
+    /* We just disconnect the connection for now ... */
+
+    RFCNB_Hangup(Con_Handle->Trans_Connect);
+
+    if (!KeepHandle)
+	free(Con_Handle);
+
+    return (0);
+
+}
Index: squid/src/auth/basic/helpers/PAM/Makefile.am
diff -u /dev/null squid/src/auth/basic/helpers/PAM/Makefile.am:1.2.28.2
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/PAM/Makefile.am	Tue Sep  3 10:42:17 2002
@@ -0,0 +1,15 @@
+#
+#  Makefile for the Squid PAM authentication helper
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+#  Uncomment and customize the following to suit your needs:
+#
+
+INCLUDES	= -I. -I$(top_builddir)/include -I$(top_srcdir)/include \
+		  -I$(top_srcdir)/src/
+
+man_MANS		= pam_auth.8
+EXTRA_DIST		= pam_auth.8
+libexec_PROGRAMS	= pam_auth
+LDADD			= -lpam $(XTRA_LIBS)
Index: squid/src/auth/basic/helpers/SASL/.cvsignore
diff -u /dev/null squid/src/auth/basic/helpers/SASL/.cvsignore:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/SASL/.cvsignore	Tue Sep  3 10:42:17 2002
@@ -0,0 +1,2 @@
+.cvsignore
+Makefile.in
Index: squid/src/auth/basic/helpers/SASL/Makefile.am
diff -u /dev/null squid/src/auth/basic/helpers/SASL/Makefile.am:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/SASL/Makefile.am	Tue Sep  3 10:42:18 2002
@@ -0,0 +1,14 @@
+#
+#  Makefile for the Squid SASL authentication helper
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+#  Uncomment and customize the following to suit your needs:
+#
+
+INCLUDES	= -I. -I$(top_builddir)/include -I$(top_srcdir)/include \
+		  -I$(top_srcdir)/src/
+
+libexec_PROGRAMS	= sasl_auth
+LDADD			= -lsasl $(XTRA_LIBS)
+EXTRA_DIST		= squid_sasl_auth squid_sasl_auth.conf
Index: squid/src/auth/basic/helpers/SASL/README
diff -u /dev/null squid/src/auth/basic/helpers/SASL/README:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/SASL/README	Tue Sep  3 10:42:18 2002
@@ -0,0 +1,49 @@
+This program authenticates users using SASL (specifically the
+cyrus-sasl authentication method).
+
+SASL is configurable (somewhat like PAM). Each service authenticating
+against SASL identifies itself with an application name. Each 
+"application" can be configured independently by the SASL administrator.
+
+For this authenticator, the SASL application name is, by default,
+
+	squid_sasl_auth
+
+To configure the authentication method used the file "squid_sasl_auth.conf" 
+can be placed in the appropriate location, usually "/usr/lib/sasl".
+
+The authentication database is defined by the "pwcheck_method" parameter.
+Only the "PLAIN" authentication mechanism is used.
+
+Examples:
+
+pwcheck_method:sasldb
+	use sasldb - the default if no conf file is installed.
+pwcheck_method:pam
+	use PAM
+pwcheck_method:passwd
+     use traditional /etc/passwd
+pwcheck_method:shadow
+     use slightly less traditional /etc/shadow
+
+Others methods may be supported by your cyrus-sasl implementation - 
+consult your cyrus-sasl documentation for information.
+
+Typically the authentication database (/etc/sasldb, /etc/shadow, pam)
+can not be accessed by a "normal" user. You should use setuid/setgid
+and an appropriate user/group on the executable to allow the
+authenticator to access the appropriate password database. If the
+access to the database is not permitted then the authenticator
+will typically fail with "-1, generic error".
+
+	chown root.mail sasl_auth
+	chmod ug+s sasl_auth
+
+If the application name ("squid_sasl_auth") will also be used for the
+pam service name if pwcheck_method:pam is chosen. And example pam
+configuration file  "squid_sasl_auth" is also included.
+
+
+Ian Castle
+ian.castle@coldcomfortfarm.net
+March 2002
Index: squid/src/auth/basic/helpers/SASL/sasl_auth.c
diff -u /dev/null squid/src/auth/basic/helpers/SASL/sasl_auth.c:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/SASL/sasl_auth.c	Tue Sep  3 10:42:18 2002
@@ -0,0 +1,103 @@
+/*
+ * $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * SASL authenticator module for Squid.
+ * Copyright (C) 2002 Ian Castle <ian.castle@coldcomfortfarm.net>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ * Install instructions:
+ *
+ * This program authenticates users against using cyrus-sasl
+ *
+ * Compile this program with: gcc -Wall -o sasl_auth sasl_auth.c -lsasl
+ *
+ */
+#include <sasl.h>
+#include <stdio.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <string.h>
+
+#define APP_NAME_SASL	"squid_sasl_auth"
+
+int
+main()
+{
+	char line[8192];
+	char *username, *password;
+	const char *errstr;
+
+	int rc;
+        sasl_conn_t *conn = NULL;
+
+	/* make standard output line buffered */
+	setvbuf(stdout, NULL, _IOLBF, 0);
+
+	rc = sasl_server_init( NULL, APP_NAME_SASL );
+
+	if ( rc != SASL_OK ) {
+		fprintf( stderr, "error %d %s\n", rc, sasl_errstring(rc, NULL, NULL ));
+		fprintf( stdout, "ERR\n" );
+		return 1;
+	}
+
+	rc = sasl_server_new( APP_NAME_SASL, NULL, NULL, NULL, 0, &conn );
+
+	if ( rc != SASL_OK ) {
+		fprintf( stderr, "error %d %s\n", rc, sasl_errstring(rc, NULL, NULL ));
+		fprintf( stdout, "ERR\n" );
+		return 1;
+	}
+
+	while ( fgets( line, sizeof( line ), stdin )) {
+		username = &line[0];
+		password = strchr( line, '\n' );
+		if ( !password) {
+			fprintf( stderr, "authenticator: Unexpected input '%s'\n", line );
+			fprintf( stdout, "ERR\n" );
+			continue;
+		}
+		*password = '\0';
+		password = strchr ( line, ' ' );
+		if ( !password) {
+			fprintf( stderr, "authenticator: Unexpected input '%s'\n", line );
+			fprintf( stdout, "ERR\n" );
+			continue;
+		}
+		*password++ = '\0';
+
+		rc = sasl_checkpass(conn, username, strlen(username), password, strlen(password), &errstr);
+
+		if ( rc != SASL_OK ) {
+			if ( errstr ) {
+				fprintf( stderr, "errstr %s\n", errstr );
+			}
+			if ( rc != SASL_BADAUTH ) {
+				fprintf( stderr, "error %d %s\n", rc, sasl_errstring(rc, NULL, NULL ));
+			}
+			fprintf( stdout, "ERR\n" );
+		}
+		else {
+			fprintf( stdout, "OK\n" );
+		}
+
+	}
+
+        sasl_dispose( &conn );
+        sasl_done();
+
+	return 0;
+}
Index: squid/src/auth/basic/helpers/SASL/squid_sasl_auth
diff -u /dev/null squid/src/auth/basic/helpers/SASL/squid_sasl_auth:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/SASL/squid_sasl_auth	Tue Sep  3 10:42:18 2002
@@ -0,0 +1,7 @@
+#%PAM-1.0
+#
+# Example PAM service configuration file if using the sasl pam password
+# backend (pwcheck_method:pam)
+#
+auth       required     /lib/security/pam_pwdb.so shadow nullok
+account    required     /lib/security/pam_pwdb.so
Index: squid/src/auth/basic/helpers/SASL/squid_sasl_auth.conf
diff -u /dev/null squid/src/auth/basic/helpers/SASL/squid_sasl_auth.conf:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/SASL/squid_sasl_auth.conf	Tue Sep  3 10:42:18 2002
@@ -0,0 +1 @@
+pwcheck_method:sasldb
Index: squid/src/auth/basic/helpers/winbind/Makefile.am
diff -u /dev/null squid/src/auth/basic/helpers/winbind/Makefile.am:1.5.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/winbind/Makefile.am	Tue Sep  3 10:42:22 2002
@@ -0,0 +1,11 @@
+#
+#  Makefile for the Squid Object Cache server
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+
+libexec_PROGRAMS = wb_auth
+wb_auth_SOURCES = wb_basic_auth.c wb_common.c
+INCLUDES = -I. -I$(top_builddir)/include -I$(top_srcdir)/include \
+    -I$(top_srcdir)/src
+LDADD = -L$(top_builddir)/lib -lmiscutil -lntlmauth
Index: squid/src/auth/basic/helpers/winbind/samba_nss.h
diff -u /dev/null squid/src/auth/basic/helpers/winbind/samba_nss.h:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/winbind/samba_nss.h	Tue Sep  3 10:42:22 2002
@@ -0,0 +1,105 @@
+#ifndef _NSSWITCH_NSS_H
+#define _NSSWITCH_NSS_H
+/* 
+   Unix SMB/Netbios implementation.
+   Version 2.0
+
+   a common place to work out how to define NSS_STATUS on various
+   platforms
+
+   Copyright (C) Tim Potter 2000
+   
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+   
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+   
+   You should have received a copy of the GNU Library General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA  02111-1307, USA.   
+*/
+
+#ifdef HAVE_NSS_COMMON_H
+
+/* Sun Solaris */
+
+#include <nss_common.h>
+#include <nss_dbdefs.h>
+#include <nsswitch.h>
+
+typedef nss_status_t NSS_STATUS;
+
+#define NSS_STATUS_SUCCESS     NSS_SUCCESS
+#define NSS_STATUS_NOTFOUND    NSS_NOTFOUND
+#define NSS_STATUS_UNAVAIL     NSS_UNAVAIL
+#define NSS_STATUS_TRYAGAIN    NSS_TRYAGAIN
+
+#elif HAVE_NSS_H
+
+/* GNU */
+
+#include <nss.h>
+
+typedef enum nss_status NSS_STATUS;
+
+#elif HAVE_NS_API_H
+
+/* SGI IRIX */
+
+/* following required to prevent warnings of double definition
+ * of datum from ns_api.h
+*/
+#ifdef DATUM
+#define _DATUM_DEFINED
+#endif
+
+#include <ns_api.h>
+
+typedef enum
+{
+  NSS_STATUS_SUCCESS=NS_SUCCESS,
+  NSS_STATUS_NOTFOUND=NS_NOTFOUND,
+  NSS_STATUS_UNAVAIL=NS_UNAVAIL,
+  NSS_STATUS_TRYAGAIN=NS_TRYAGAIN
+} NSS_STATUS;
+
+#define NSD_MEM_STATIC 0
+#define NSD_MEM_VOLATILE 1
+#define NSD_MEM_DYNAMIC 2
+
+#elif defined(HPUX)
+/* HP-UX 11 */
+
+#include "nsswitch/hp_nss_common.h"
+#include "nsswitch/hp_nss_dbdefs.h"
+#include <nsswitch.h>
+
+#ifndef _HAVE_TYPEDEF_NSS_STATUS
+#define _HAVE_TYPEDEF_NSS_STATUS
+typedef nss_status_t NSS_STATUS;
+
+#define NSS_STATUS_SUCCESS     NSS_SUCCESS
+#define NSS_STATUS_NOTFOUND    NSS_NOTFOUND
+#define NSS_STATUS_UNAVAIL     NSS_UNAVAIL
+#define NSS_STATUS_TRYAGAIN    NSS_TRYAGAIN
+#endif /* HPUX */
+
+#else /* Nothing's defined. Neither gnu nor sun nor hp */
+
+typedef enum
+{
+  NSS_STATUS_SUCCESS=0,
+  NSS_STATUS_NOTFOUND=1,
+  NSS_STATUS_UNAVAIL=2,
+  NSS_STATUS_TRYAGAIN=3
+} NSS_STATUS;
+
+#endif
+
+#endif /* _NSSWITCH_NSS_H */
Index: squid/src/auth/basic/helpers/winbind/wb_basic_auth.c
diff -u /dev/null squid/src/auth/basic/helpers/winbind/wb_basic_auth.c:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:40 2004
+++ squid/src/auth/basic/helpers/winbind/wb_basic_auth.c	Tue Sep  3 10:42:22 2002
@@ -0,0 +1,121 @@
+/*
+ * (C) 2000 Francesco Chemolli <kinkie@kame.usr.dsi.unimi.it>
+ *
+ * Distributed freely under the terms of the GNU General Public License,
+ * version 2. See the file COPYING for licensing details
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+
+#include "wbntlm.h"
+#include "util.h"
+/* stdio.h is included in wbntlm.h */
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <sys/time.h>           /* for gettimeofday */
+#include <errno.h>              /* BUG: is this portable? */
+
+#include "winbind_nss_config.h"
+#include "winbindd_nss.h"
+
+char debug_enabled=1;
+char *myname;
+pid_t mypid;
+
+NSS_STATUS winbindd_request(int req_type, 
+														struct winbindd_request *request,
+														struct winbindd_response *response);
+		 
+
+void do_authenticate(char *user, char *pass) {
+	struct winbindd_request request;
+	struct winbindd_response response;
+	NSS_STATUS winbindd_result;
+	
+	memset(&request,0,sizeof(struct winbindd_request));
+	memset(&response,0,sizeof(struct winbindd_response));
+
+	
+	strncpy(request.data.auth.user,user,sizeof(fstring)-1);
+	strncpy(request.data.auth.pass,pass,sizeof(fstring)-1);
+
+	winbindd_result = winbindd_request(WINBINDD_PAM_AUTH,
+																		 &request, &response);
+	debug("winbindd result: %d\n",winbindd_result);
+
+	if (winbindd_result==WINBINDD_OK) {
+		SEND("OK");
+	} else {
+		SEND("ERR");
+	}
+
+	return;												/* useless */
+}
+
+void manage_request(void) {
+  char buf[BUFFER_SIZE+1];
+	int length;
+	char *c, *user, *pass;
+  
+  if (fgets(buf, BUFFER_SIZE, stdin) == NULL) {
+    warn("fgets() failed! dying..... errno=%d (%s)\n", errno,
+          strerror(errno));
+    exit(1);    /* BIIG buffer */
+  }
+	
+  c=memchr(buf,'\n',BUFFER_SIZE);
+  if (c) {
+    *c='\0';
+		length=c-buf;
+	}
+  else {
+    warn("No newline in '%s'. Dying.\n",buf);
+		exit(1);
+	}
+  
+  debug("Got '%s' from squid (length: %d).\n",buf,length);
+	user=buf;
+
+	pass=memchr(buf,' ',length);
+	if (!pass) {
+		warn("Password not found. Denying access\n");
+		SEND("ERR");
+		return;
+	}
+	*pass='\0';
+	pass++;
+
+	do_authenticate(user,pass);
+
+}
+
+int main (int argc, char ** argv) {
+	if (argc > 0) {								/* should always be true */
+		myname=strrchr(argv[0],'/');
+		if (myname==NULL)
+			myname=argv[0];
+	} else {
+		myname="(unknown)";
+	}
+	mypid=getpid();
+  debug("ntlm winbindd auth helper build " __DATE__ ", " __TIME__
+        " starting up...\n");
+  /* initialize FDescs */
+  setbuf(stdout, NULL);
+  setbuf(stderr, NULL);
+
+  while(1) {
+    manage_request();
+  }
+  return 0;
+}
